# =============================================================
#                CodeTyphon Studio
#      Copyright (c) PilotLogic Software House.
#               All rights reserved.
# =============================================================

docleanall() 
{

if [ -f /usr/bin/fpcmake ] ;
then
  sudo rm -f /usr/bin/fpcmake
fi

if [ -f /usr/bin/${cbTARGETCPUOS}-as ] ;
then
  sudo rm -f /usr/bin/${cbTARGETCPUOS}-as
fi

if [ -d $vFpcDir/newfpc ] ;
then 
  sudo rm -rf $vFpcDir/newfpc
fi

if [ -d $vCTDir/binutils ] ;
then    
    sudo rm -rf $vCTDir/binutils
fi

if [ -d $vCTDir/binutilstemp ] ;
then     
    sudo rm -rf $vCTDir/binutilstemp
fi

}

#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

dothejob() 
{

if [ $cbTARGETCPUOS = $cbFPCCPUOS ] ;
then 
  exit
fi

# ================= Check Elements Engine Switch  =================================

if [ -f $vCTDir/Settings/CT_Cross_FPC_Elements_Engine_Disabled.ctsw ] ;
then
  echo "   "
  echo "[INFO]: Cross CT FPC Elements Engine Switch is OFF"
  echo "        Cross Build procedure STOP."
  echo "   "
  exit
fi

# ================= Build FPC cross compiler ======================================

echo "====================================================================="
echo "    Build Cross Element for $cbTARGETCPUOS Param:$cbParam"
echo "====================================================================="
echo "   "

# sleep 120

if [ ! -d $vFpcSrcDir ] ;
then   
  echo "???????????????????????????????????????????????????????????"
  echo " [ERROR]:FreePascal Source directory NOT exists"
  echo "         sorry, Cross Build procedure STOP" 
  echo "??????????????????????????????????????????????????????????"
  docleanall
  exit
fi

if [ -d $vFpcDir/newfpc ] ;
then     
    echo "[INFO]: Remove OLD FreePascal temporary build folder..."
    sudo rm -rf $vFpcDir/newfpc
fi

if [ -d $vCTDir/binToolchains/${cbbincross} ] ;
then
  echo "[INFO]: Copy Files from ToolsChains Library..."
  sudo cp -f $vCTDir/binToolchains/${cbbincross}/* $vFpcExeDir/
  sudo chmod -R 777 $vFpcExeDir
else    
  echo "???????????????????????????????????????????????????????????"
  echo "   [ERROR]: Can NOT find files for $cbTARGETCPUOS Param:$cbParam" 
  echo "            in Toolschains Library." 
  echo "            sorry, Cross Build procedure STOP" 
  echo "??????????????????????????????????????????????????????????" 
  exit
fi

# =======================================================

cd $vFpcSrcDir

echo "------------------------------------------------"
echo "      Stage 0: Clean FreePascal $cbFPCStartEXE" 
echo "------------------------------------------------"
sudo $vMake clean PP=$vFpcBinDir/$cbFPCCPUOS/$cbFPCStartEXE

# ------------------- Make Links -------------------------------------
if [ -f $vFpcBinDir/$cbFPCCPUOS/fpcmake ] ;
then
  sudo ln -f -s $vFpcBinDir/$cbFPCCPUOS/fpcmake /usr/bin/fpcmake
fi

if [ -f $vFpcBinDir/$cbFPCCPUOS/${cbTARGETCPUOS}-as ] ;
then 
  sudo ln -f -s $vFpcBinDir/$cbFPCCPUOS/${cbTARGETCPUOS}-as /usr/bin/${cbTARGETCPUOS}-as
fi

# -------------------------------------------------------------------
# sleep 120
# -------------------------------------------------------------------

echo "------------------------------------------------"
echo "       Stage 1: Build Cross Compiler Executable" 
echo "------------------------------------------------"

if [ $vOSName = solaris ] ;
then   
  sudo $vMake compiler_cycle OPT="-Xn" FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCStartEXE
  sudo $vMake -C utils/fpcm all OPT="-Xn" FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCStartEXE
  sudo $vMake all CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS OPT="-Xn" FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCStartEXE OPT="-dFPC_ARMHF"
else  
  sudo $vMake compiler_cycle FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCStartEXE OPT="-dFPC_ARMHF"
  sudo $vMake -C utils/fpcm all FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCStartEXE OPT="-dFPC_ARMHF"
  sudo $vMake all CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCStartEXE OPT="-dFPC_ARMHF"
fi

if [ ! -f $vFpcSrcDir/compiler/$cbFPCCrossEXE ] ;
then  
  echo "???????????????????????????????????????????????????????????"
  echo " [ERROR]:Cross compiler $cbFPCCrossEXE  NOT Builded"
  echo "         sorry, Cross Build procedure STOP" 
  echo "??????????????????????????????????????????????????????????"
  docleanall
  exit
else
 sudo cp -f $vFpcSrcDir/compiler/$cbFPCCrossEXE $vFpcBinDir/$cbFPCCPUOS/
 sudo chmod -R 777 $vFpcBinDir/$cbFPCCPUOS
 echo "   "
 echo "[INFO]: !!! Cross compiler Executable $cbFPCCrossEXE, Build OK. !!!"
 echo "   "
fi

# -------------------------------------------------------------------
# sleep 120
# -------------------------------------------------------------------

echo "------------------------------------------------"
echo "       Stage 2: Build All Units and Packages" 
echo "------------------------------------------------"

sudo $vMake -C rtl clean CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCCrossEXE
sudo $vMake -C packages clean CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCCrossEXE
sudo $vMake rtl packages CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCCrossEXE OPT="-CaEABIHF -CpARMV6 -CfVFPV2 -OoFASTMATH"

# -------------------------------------------------------------------
# sleep 120
# -------------------------------------------------------------------

echo "------------------------------------------------"
echo "       Stage 3: Install All Units and Packages " 
echo "------------------------------------------------"

sudo $vMake rtl_install packages_install CPU_TARGET=$cbTARGETCPU OS_TARGET=$cbTARGETOS FPC=$vFpcBinDir/$cbFPCCPUOS/$cbFPCCrossEXE PREFIX=/usr/lib/codetyphon/fpc/newfpc/ 


echo "------------------------------------------------"
echo "       Stage 4: Copy Files and Units" 
echo "------------------------------------------------"

if [ -d $vFpcDir/newfpc/lib/fpc/$vFpcVer/units ] ;
then
 echo "   "
 echo "[INFO]: Move FPC Cross compiler units..."
 sudo cp -fr $vFpcDir/newfpc/lib/fpc/$vFpcVer/units/* $vFpcDir/units/
fi

echo "------------------------------------------------"
echo "       Clean FreePascal Directory " 
echo "------------------------------------------------"

sudo $vMake clean PP=$vFpcBinDir/$cbFPCCPUOS/$cbFPCStartEXE

docleanall

sudo chmod -R 777 $vFpcBinDir
sudo chmod -R 777 $vFpcDir

# ===================Final Check ===================================

if [ -d $vFpcDir/units/$cbTARGETCPUOS ] ;
then 
    echo "   "
    echo "[FINAL INFO]:-- !!! $cbTARGETCPUOS Param:$cbParam Cross Build Element Build OK !!! --"
    echo "   "
else
    echo "   "
    echo " ???????????????????????????????????????????????????????????"
    echo "  [ERROR]: Cross Element for $cbTARGETCPUOS Param:$cbParam NOT Exists" 
    echo "           sorry, Cross Build procedure STOP"
    echo " ???????????????????????????????????????????????????????????"
    echo "   " 
fi

}

#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

# =================== MAIN =============================
. /usr/lib/codetyphon/ScriptsLin/ln_All_Functions.sh
getvalues

cbFPCType=$1
cbFPCCPUOS=$2
cbFPCStartEXE=$3
cbTARGETCPU=$4
cbTARGETOS=$5
cbFPCCrossEXE=$6
cbParam=$7

cbTARGETCPUOS=${cbTARGETCPU}-${cbTARGETOS}

if [ $cbParam = xxxx ] ; 
then 
  cbbincross=${cbFPCType}-${cbTARGETCPUOS}
else
  cbbincross=${cbFPCType}-${cbTARGETCPUOS}--${cbParam}
fi

echo "-------- Cross (armv6) Level-2 settings $cbTARGETCPUOS Param:$cbParam ----"
echo $cbFPCType
echo $cbFPCCPUOS
echo $cbFPCStartEXE
echo $cbTARGETCPU
echo $cbTARGETOS
echo $cbFPCCrossEXE
echo $cbTARGETCPUOS
echo $cbParam
echo $cbbincross
echo "   "

dothejob

